# 参数详解

## 1.全部启动参数
```js
//启动参数的默认值
const args = {
  pattern:'node',
  rootPath:"",
  srcList:["./app"],
  moduleList:[],
  tempJsName:".runtemp.js",
  configPaths:['./resource/app-dev.yaml'],
  inputArgs:[],//无需改动!
  packageName:'j-spring', //无需改动!
  logPackageName:'j-spring',
  annotation:{ //配置系统默认注解
    valueInject:"Value",
    appBoot:"SpringBoot",
    beanInject:"Autowired",
    springFactory:"SpringFactory",
    springResource:"SpringResource",
    proxy:"Proxy",
    logInject:"log"
  }
}

new SpringBoot(args).start();

```
- **pattern** 生成脚本的文件头  node(默认),shell
- **rootPath** 项目根路径
- **srcList** 需要扫描的源码目录集合
- **moduleList** 加载的npm包集合
- **tempJsName** 生成临时文件名称
- **configPaths** 加载的配置文件路径 支持绝对路径
- **inputArgs** 自动获取，无需传入
- **packageName** 调试j-spring源码时使用，无需传入
- **logPackageName** 扩展的日志包
- **annotation** 系统默认的注解名称，例如把@Autowired改成@Resrouce
```js
const args = {
    annotation:{
      beanInject:"Resource",
    }
}
```
