# Annotation



## 1.注解标识

在修改Node源码后，是可以支持类似java的原生注解,例如@Annotation。但实际体验并不好，首先干扰编辑器的高亮和代码提示，其次不同环境下都需要重新编译Node，甚是麻烦。这种魔改可能会遇到各种未知情况，臣妾深感不安。

```js

/**

   '//@' 开头 + Java的类名规则 + <参数设置>

*/

//@AnnotationName<(a=x,b=x)>


```

## 源码定义
```js
class Annotation {

  /**
    type:String
    remark:注解名称 不要@
  */
	name;

  /**
    type:Object
    remark:解析注解携带的参数
      @Value => {}
      @Value(config.name) => {value:"config.name"}
      @Value(a=1,b=2) => {a:"1",b:2}
  */
	param={};

}
```

## 2.注解属性
```js
 //所有注解都只有两个属性,name和param;
 class Annotation {
   name:String //注解的名称
   param:Object //注解定义的参数
 }
```

## 3.常用定义
```js

/**  1.缺省参数注解定义
     实际解析:
     {
       name:'Annotation1',
       param:{}
     }
 */

//@Annotation1


/**  2.简单参数注解定义
    实际解析:
    {
      name:"Annotation2",
      param:{'value':'abc'}
    }
*/

//@Annotation2(abc)


/**  3.复杂参数注解定义
    实际解析：
    {
      name:"Annotation3",
      param:{a:'1',b:'xxx',c:'3'} //所有的值都只解析成字符串。
    }
*/


//@Annotation3(a=1,b=xxx,c=3)


```

## 4.定义范围

- 支持类，方法，字段  
- 支持多重注解

```js

  /** 1.类注解  */

  //@Hello
  //@Peg(a=b)
  class HelloWorld {


    /** 2.字段注解  */

    //@Value(config.msg)
    msg;

    /** 3.方法注解  */

    //@ToDo
    async say(guy,msg){

    }

  }

```
