# bean的定义

## 任意注解定义
> 只要类名上添加任意合法注解均会被扫描到。

```js
/**
解析后的 BeanDfine {
  name:'jSpring'; //一把情况下取类名首字母小写
}
*/

//@AnnotationX
class JSpring {

}

```

## @Bean注解定义
> @Bean是j-spring内置注解，用于指定BeanDefine的name属性

```js
/**
解析后的BeanDfine {
  name:'j.spring';//取@Bean的参数
}
*/

//@Bean(j.spring)
//@AnnotationX
class JSpring {

}
```

# bean的注入

## 字段名注入
> 从容器中查找name等于'jSpring'的BeanDefine，装配完成后注入。

```js

//@SpringBoot
class Application {
  //@Autowired
  jSpring;
}

```

## 指定名称注入
> 从容器中查找name等于'j.spring'的BeanDefine，装配完成后注入。

```js

//@SpringBoot
class Application {
  //@Autowired(j.spring)
  jSpring;
}

```

## 手动注入
```js
//@SpringBoot
class Application {

  jSpring;

	//@Autowired
	springFactory;

	async main(){

      //1.拿到beanDefine
      const jSpringBeanDefine =  this.springFactory.getBeanDefineByName('j.spring')

      //2.自动装配BeanDefine拿到最终的Bean
      const jSpring = await this.springFactory.assembleBeanByBeanDefine(jSpringBeanDefine)

      this.jSpring =jSpring;

	}

}
```
